'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.NotificationsContainer = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _ReactCSSTransitionGroup = require('react/lib/ReactCSSTransitionGroup');

var _ReactCSSTransitionGroup2 = _interopRequireDefault(_ReactCSSTransitionGroup);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _Notification = require('./Notification');

var _Notification2 = _interopRequireDefault(_Notification);

var _constants = require('../constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var NotificationsContainer = exports.NotificationsContainer = function (_Component) {
  _inherits(NotificationsContainer, _Component);

  /**
   * Constructor
   * Bind methods
   * @param {Object} props
   * @returns {void}
   */

  // default types

  function NotificationsContainer(props) {
    _classCallCheck(this, NotificationsContainer);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(NotificationsContainer).call(this, props));

    _this._renderNotifications = _this._renderNotifications.bind(_this);
    return _this;
  }

  /**
   * Render notifications
   * @private
   * @returns {XML}
   */


  // Properties types


  _createClass(NotificationsContainer, [{
    key: '_renderNotifications',
    value: function _renderNotifications() {
      // get all notifications and default values for notifications
      var _props = this.props;
      var position = _props.position;
      var className = _props.theme.notification.className;
      var _props$defaultValues = _props.defaultValues;
      var status = _props$defaultValues.status;
      var dismissible = _props$defaultValues.dismissible;
      var dismissAfter = _props$defaultValues.dismissAfter;
      var closeButton = _props$defaultValues.closeButton;
      var allowHTML = _props$defaultValues.allowHTML;
      var notifications = this.props.notifications;

      // when notifications are displayed at the bottom,
      // we display notifications from bottom to top

      if ([_constants.POSITIONS.bottomLeft, _constants.POSITIONS.bottomRight, _constants.POSITIONS.bottomCenter, _constants.POSITIONS.bottom].indexOf(position) >= 0) {
        notifications = notifications.reverse();
      }

      return notifications.map(function (notification) {
        // Define default values for notification if it's needed
        if (!notification.status) {
          notification.status = status;
        }
        if (typeof notification.dismissible !== 'boolean') {
          notification.dismissible = dismissible;
        }
        if (typeof notification.dismissAfter !== 'number') {
          notification.dismissAfter = dismissAfter;
        }
        if (typeof notification.closeButton !== 'boolean') {
          notification.closeButton = closeButton;
        }
        if (typeof notification.allowHTML !== 'boolean') {
          notification.allowHTML = allowHTML;
        }
        return _react2.default.createElement(_Notification2.default, { key: notification.id, notification: notification, className: className });
      });
    }

    /**
     * Render
     * @returns {XML}
     */

  }, {
    key: 'render',
    value: function render() {
      var _props$theme$notifica = this.props.theme.notificationsContainer;
      var className = _props$theme$notifica.className;
      var _props$theme$notifica2 = _props$theme$notifica.transition;
      var name = _props$theme$notifica2.name;
      var appearTimeout = _props$theme$notifica2.appearTimeout;
      var enterTimeout = _props$theme$notifica2.enterTimeout;
      var leaveTimeout = _props$theme$notifica2.leaveTimeout;
      var position = this.props.position;

      return _react2.default.createElement(
        'div',
        { className: className.main + ' ' + className.position(position) },
        _react2.default.createElement(
          _ReactCSSTransitionGroup2.default,
          { transitionName: name, transitionAppear: true,
            transitionAppearTimeout: appearTimeout, transitionEnterTimeout: enterTimeout,
            transitionLeaveTimeout: leaveTimeout },
          this._renderNotifications()
        )
      );
    }
  }]);

  return NotificationsContainer;
}(_react.Component);

NotificationsContainer.defaultProps = {
  notifications: []
};
NotificationsContainer.propTypes = {
  notifications: _react2.default.PropTypes.array.isRequired,
  position: _react2.default.PropTypes.string.isRequired,
  defaultValues: _react2.default.PropTypes.shape({
    status: _react2.default.PropTypes.string.isRequired,
    position: _react2.default.PropTypes.oneOf(_lodash2.default.values(_constants.POSITIONS)),
    dismissible: _react2.default.PropTypes.bool.isRequired,
    dismissAfter: _react2.default.PropTypes.number.isRequired,
    closeButton: _react2.default.PropTypes.bool.isRequired,
    allowHTML: _react2.default.PropTypes.bool.isRequired
  }),
  theme: _react2.default.PropTypes.shape({
    notificationsContainer: _react2.default.PropTypes.shape({
      className: _react2.default.PropTypes.shape({
        main: _react2.default.PropTypes.string.isRequired,
        position: _react2.default.PropTypes.func.isRequired
      }),
      transition: _react2.default.PropTypes.shape({
        name: _react2.default.PropTypes.object.isRequired,
        enterTimeout: _react2.default.PropTypes.number.isRequired,
        leaveTimeout: _react2.default.PropTypes.number.isRequired
      })
    }),
    notification: _react2.default.PropTypes.shape({
      className: _react2.default.PropTypes.object.isRequired
    })
  })
};
exports.default = NotificationsContainer;